//----------------------------------------------------------------------------
// agftp.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: agftp.pas
//----------------------------------------------------------------------------
#ifndef agftpHPP
#define agftpHPP
//----------------------------------------------------------------------------
#include <agFtpCls.hpp>
#include <agtypes.hpp>
#include <agsocket.hpp>
#include <agwsock.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Agftp
{
//-- type declarations -------------------------------------------------------
enum TTransferType { ftBinary, ftASCII };

class __declspec(delphiclass) TagFTP;
class __declspec(pascalimplementation) TagFTP : public Agsocket::TagSocket
{
	typedef Agsocket::TagSocket inherited;
	
private:
	int FDataSocket;
	int FListenerSocket;
	System::AnsiString FUserName;
	System::AnsiString FPassword;
	TTransferType FTransferType;
	Classes::TNotifyEvent FOnTransferStart;
	Agtypes::TmsProgressEvent FOnTransferProgress;
	Classes::TNotifyEvent FOnTransferEnd;
	Classes::TStream* FTransferStream;
	Agftpcls::TagFTPDirList* FDirectory;
	Cardinal FTransferBufferSize;
	bool FRetrievingList;
	bool FTransferringFile;
	Agftpcls::TServerType __fastcall GetServerType(void);
	void __fastcall SetServerType(Agftpcls::TServerType Value);
	System::AnsiString __fastcall GetCurrentDirectory(void);
	void __fastcall SetCurrentDirectory( System::AnsiString Value);
	void __fastcall DoTransferStart(System::TObject* Sender);
	void __fastcall DoTransferProgress(System::TObject* Sender, int Perc, long Transferred);
	void __fastcall DoTransferEnd(System::TObject* Sender);
	
protected:
	int DataWndHandle;
	bool DataConnectionClosed;
	bool DataTransferCanceled;
	HIDESBASE void __fastcall WndProc(Messages::TMessage &Msg);
	virtual void __fastcall ReInit(void);
	void __fastcall OpenListenerSocket(void);
	void __fastcall CloseListenerSocket(void);
	void __fastcall RequestDataConnection(void);
	void __fastcall AcceptDataConnection(void);
	void __fastcall CloseDataConnection(void);
	void __fastcall RecvFTPStream(long FullSize);
	void __fastcall SendFTPStream(long FullSize);
	void __fastcall FillDirList(void);
	
public:
	__fastcall virtual TagFTP(Classes::TComponent* AOwner);
	__fastcall virtual ~TagFTP(void);
	virtual void __fastcall Open(void);
	void __fastcall OpenConnection(void);
	void __fastcall CloseConnection(void);
	void __fastcall LogIn(void);
	void __fastcall LogOut(void);
	void __fastcall RetrieveFile(const System::AnsiString RemoteFilePath, const System::AnsiString LocalFilePath
		);
	void __fastcall ResumeRetrieveFile(const System::AnsiString RemoteFilePath, const System::AnsiString 
		LocalFilePath, long Marker);
	void __fastcall StoreFile(const System::AnsiString LocalFilePath, const System::AnsiString RemoteFilePath
		);
	void __fastcall ResumeStoreFile(const System::AnsiString LocalFilePath, const System::AnsiString RemoteFilePath
		, long Marker);
	void __fastcall AppendStoreFile(const System::AnsiString LocalFilePath, const System::AnsiString RemoteFilePath
		);
	void __fastcall StoreUnique(const System::AnsiString LocalFilePath,  System::AnsiString &RemoteFilePath
		);
	void __fastcall GetDirectory(void);
	void __fastcall DeleteFile(const System::AnsiString FileName);
	void __fastcall RenameFile(const System::AnsiString OldFileName, const System::AnsiString NewFileName
		);
	void __fastcall ChangeDirectory(const System::AnsiString Path);
	void __fastcall ChangeToUpperDirectory(void);
	void __fastcall MakeDirectory(const System::AnsiString Path);
	void __fastcall DeleteDirectory(const System::AnsiString Path);
	void __fastcall AbortTransfer(void);
	__property Agftpcls::TagFTPDirList* Directory = {read=FDirectory, write=FDirectory, nodefault};
	__property bool RetrievingList = {read=FRetrievingList, nodefault};
	__property bool TransferringFile = {read=FTransferringFile, nodefault};
	__property System::AnsiString CurrentDirectory = {read=GetCurrentDirectory, write=SetCurrentDirectory
		, nodefault};
	
__published:
	__property Server ;
	__property DefaultPort ;
	__property TimeOut ;
	__property OnOpen ;
	__property OnConnected ;
	__property OnClosing ;
	__property OnClosed ;
	__property OnCancel ;
	__property OnError ;
	__property OnLineSent ;
	__property OnLineReceived ;
	__property System::AnsiString UserName = {read=FUserName, write=FUserName, nodefault};
	__property System::AnsiString Password = {read=FPassword, write=FPassword, nodefault};
	__property Agftpcls::TServerType ServerType = {read=GetServerType, write=SetServerType, nodefault};
		
	__property Cardinal TrasferBufferSize = {read=FTransferBufferSize, write=FTransferBufferSize, default=2048
		};
	__property TTransferType TransferType = {read=FTransferType, write=FTransferType, default=0};
	__property Classes::TNotifyEvent OnTransferStart = {read=FOnTransferStart, write=FOnTransferStart};
		
	__property Agtypes::TmsProgressEvent OnTransferProgress = {read=FOnTransferProgress, write=FOnTransferProgress
		};
	__property Classes::TNotifyEvent OnTransferEnd = {read=FOnTransferEnd, write=FOnTransferEnd};
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Agftp */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Agftp;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// agftp
